# Enum Class CATypePackageVersionBehavior

java.lang.Object
java.lang.Enum<CATypePackageVersionBehavior>
com.io7m.cardant.model.type_package.CATypePackageVersionBehavior

All Implemented Interfaces:
  `Serializable, Comparable<CATypePackageVersionBehavior>, Constable`

public enum CATypePackageVersionBehavior extends Enum<CATypePackageVersionBehavior>
The type removal behavior for package upgrades/uninstalls.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VERSION_ALLOW_DOWNGRADES`
  Allow moving from any version to a lower version.
  `VERSION_DISALLOW_DOWNGRADES`
  Disallow moving from any version to a lower version.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static CATypePackageVersionBehavior`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static CATypePackageVersionBehavior[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VERSION_ALLOW_DOWNGRADES

    public static final CATypePackageVersionBehavior VERSION_ALLOW_DOWNGRADES
    Allow moving from any version to a lower version.

  - ### VERSION_DISALLOW_DOWNGRADES

    public static final CATypePackageVersionBehavior VERSION_DISALLOW_DOWNGRADES
    Disallow moving from any version to a lower version.

- ## Method Details

  - ### values

    public static CATypePackageVersionBehavior[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static CATypePackageVersionBehavior valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null